
var Cc = require("chrome").Cc;
var Ci = require("chrome").Ci;
var Cu = require("chrome").Cu;

Cu.import("resource://gre/modules/ctypes.jsm");
Cu.import("resource://gre/modules/FileUtils.jsm");
Cu.import("resource://gre/modules/AddonManager.jsm");

var libPath = null;


/*** NATIVE JS-CTYPES ***/

function initLibPath() {

	if (libPath == null) {
	
		var xulRuntime = Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULRuntime);
		var isWindows = (xulRuntime.OS === 'WINNT');
		var isLinux = (xulRuntime.OS === 'Linux');
		var isMac = (xulRuntime.OS === 'Darwin');
		var is64bit = (xulRuntime.XPCOMABI.indexOf('x86_64') > -1);
		
		var testdll = "test.dll";
		
		if (!isWindows) {
			if (isLinux) {
				testdll = is64bit ? "libtest-64.so" : "libtest.so";
			} else if (isMac) {
				testdll = "libtest.dylib";
			}
		}

		libPath = FileUtils.getFile("ProfD", ["extensions", "jid2-HfFCNbAsKx6AoF@jetpack", "resources", "test", "data", testdll]).path; 
	}
}

/*** BROWSER EVENTS ***/

function getVersionInfo() {

	// init library path
	initLibPath();
	
	// open native lib
	var lib = ctypes.open(libPath);
	
	// get native version
	var version = lib.declare('MyGetVersion', ctypes.default_abi, ctypes.int)();

	// updating widget tooltip
	console.error("TEST-VERSION: " + version);
		
	// close native lib
	lib.close();
}

exports.main = function (options, callbacks) {

	getVersionInfo();

	var reason = options.loadReason;

	if ((reason == "install") || (reason == "upgrade")) {

	}
};

exports.onUnload = function (reason) {

};

